﻿using Proto;

namespace TestProject;

/// <summary>
/// 헬로우 액터
/// </summary>
public class HelloActor : IActor
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 수신하기 (비동기) - ReceiveAsync(context)

    /// <summary>
    /// 수신하기 (비동기)
    /// </summary>
    /// <param name="context">컨텍스트</param>
    /// <returns>태스크</returns>
    public Task ReceiveAsync(IContext context)
    {
        switch(context.Message)
        {
            case HelloMessage helloMessage :

                Console.WriteLine($"안녕하세요, {helloMessage.Name}");

                break;

            case Started _ :

                Console.WriteLine("시작했습니다, 여기서 액터를 초기화합니다.");

                break;

            case Stopping _ :

                Console.WriteLine("중단중입니다, 액터가 곧 셧 다운됩니다.");

                break;

            case Stopped _ :

                Console.WriteLine("중단했습니다, 액터와 그 자식들이 중단되었습니다.");

                break;

            case Restarting _ :

                Console.WriteLine("재시작하고 있습니다, 액터가 곧 재시작됩니다.");

                break;
        }

        return Task.CompletedTask;
    }

    #endregion
}