﻿using Proto;
using Proto.Extensions;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
static class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 시작하기 - Main()

    /// <summary>
    /// 시작하기
    /// </summary>
    /// <returns>태스크</returns>
    private static async Task Main()
    {
        ActorSystem actorSystem = new ActorSystem();

        actorSystem.EventStream.Subscribe<DeadLetterEvent>
        (
            deadLetter => Console.WriteLine
            (
                $"DeadLetter from {deadLetter.Sender} to {deadLetter.Pid} : {deadLetter.Message.GetMessageTypeName()} = '{deadLetter.Message}'"
            )
        );

        RootContext rootContext = new RootContext(actorSystem);

        Props helloProps = Props.FromProducer(() => new HelloActor());

        PID helloActorPID = rootContext.Spawn(helloProps);

        rootContext.Send(helloActorPID, new HelloMessage { Name = "홍길동" });

        await actorSystem.Root.PoisonAsync(helloActorPID);
    }

    #endregion
}